package upsControl;


import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;

/**
 * Класс для отправки (а потом - и приема) SMS, потому что 
 * оказалось, что с ТС65 не работает WTK25, в котором вся эта
 * обработка есть.
 * @author dvk
 *
 */

/**
 * @author - gsmpager.ru
 *
 */
public class SMSSendReceive {
	private ATCommand atCommand;
	private MenuSettings menuSettings;
	private byte sbuf[];
//	String smsReceivedText;
//	String smsReceivedFromNumber;
	
	// Текст, отправитель, время отправки последнего принятого СМС
	public PDU pdu;
	public String strLastSms;
	public String strLastSender;
	public int iLastSenderType;
	public String strLastSmsTime;
	
	public SMSSendReceive(ATCommand atCommand, MenuSettings menuSettings)
	{
		this.atCommand = atCommand;
		this.menuSettings = menuSettings;
		sbuf = new byte[512]; // С запасом 
		pdu = new PDU();
		strLastSms = new String();
		strLastSender = new String();
		strLastSmsTime = new String();
		iLastSenderType = -1;
	}
/**
 * Настройка модема для передачи SMS, выполняется один раз
 * при запуске программы.
 * @return true = ОК.
 */	
	
	boolean init()
	{
		boolean bRet = true;
		
		// Здесь надо послать в модем настройки СМС-канала
		try 
		{
//			atCommand.send("AT+CMGF=0\r");// use PDU mode
			menuSettings.DebugOut("\n\r"+atCommand.send("AT+CMGF=0\r")+"\n\r");
//			atCommand.send("AT+CSCS=\"UCS2\"\r");// UCS encoding
			menuSettings.DebugOut(atCommand.send("AT+CSCS=\"UCS2\"\r")+"\n\r");
//			atCommand.send("AT+CPMS=\"SM\",\"SM\",\"SM\"\r");// UCS encoding
			menuSettings.DebugOut(atCommand.send("AT+CPMS=\"SM\",\"SM\",\"SM\"\r")+"\n\r");
//			atCommand.send("AT+CNMI=1,1\r");// Report incoming SMS
			menuSettings.DebugOut(atCommand.send("AT+CNMI=1,1\r")+"\n\r");
		} 
		catch (IllegalStateException e) 
		{
			menuSettings.DebugOut("\n\r"+e.getMessage()+"\n\r");
		} 
		catch (IllegalArgumentException e) 
		{
			menuSettings.DebugOut("\n\r"+e.getMessage()+"\n\r");
		} 
		catch (ATCommandFailedException e) 
		{
			menuSettings.DebugOut("\n\r"+e.getMessage()+"\n\r");
		}
		
		return bRet;
	}

	
/**
 * Читает последний полученный SMS командой at+cmgl=0
 * @return true если SMS принят
 */	
	public boolean receiveSMS()
	{
		boolean bRet = false;
		try 
		{
			String strReply = atCommand.send("AT+CMGL=0\r");
			//menuSettings.DebugOut(strReply+"\n\r");
			int pos = strReply.indexOf("+CMGL:");
			boolean badFmt = true;
			if(strReply.length() < 30) // Просто ОК - это нормально
				badFmt = false;
			else
			{
				menuSettings.DebugOut("+CMGL:@:"+pos+", strReply.length()="+
						strReply.length()+"\n\r");
				
				if(pos != -1) // есть PDU
				{
					pos++;
					// Ищем Enter  в строке +CMGL: xx,yy,zz
					pos = strReply.indexOf(0x0d, pos);
					if(pos != -1)
					{
						pos+=2;
						// Ищем Enter после PDU
						int pos2 = strReply.indexOf(0x0d, pos); 
						//menuSettings.DebugOut("\n\rpos(Enter)="+pos+", pos2="+pos2+"\n\r");
						if(pos2 != -1)
						{
							String strPDU = strReply.substring(pos, pos2);
							menuSettings.DebugOut("PDU: "+strPDU+"(end PDU)\n\r");
							strLastSms = pdu.ParsePDU(strPDU);
							strLastSender = pdu.smsSenderID;
							iLastSenderType = pdu.smsSenderIDType;
							strLastSmsTime = pdu.smsTime;
							
							menuSettings.DebugOut("Last SMS: " + strLastSms +
									"from " + strLastSender + " of type " + 
									Integer.toString(iLastSenderType) + 
									" received at " + strLastSmsTime + "\n\r");
							badFmt = false;
							bRet = true;
						}
					}
				}
			}
			if(badFmt == true)
				menuSettings.DebugOut("Bad CMGL: format:"+strReply+"\n\r");
		} 
		catch (IllegalStateException e) 
		{
			e.printStackTrace();
		} 
		catch (IllegalArgumentException e) 
		{
			e.printStackTrace();
		} 
		catch (ATCommandFailedException e) 
		{
			e.printStackTrace();
		}
		return bRet;
	}
/*	
	private byte hex2bin(byte c)  
	{
		return (byte)( ((((c)&0x4F)&0x40)!=0) ? (((c)&0x4F)-0x37) : ((c)&0x4F) );
	}
*/
	private byte bin2hex(byte n)
	{
		n = (byte)(n & 0x0F); 
		if(n>9) 
			return (byte)(n-10+'A'); 
		else return (byte)(n+'0');
	}

	private int create_pdu_mem(byte num[], char msg[])
	{
	int i;
	int j;
	byte n;
	short u;

	for (i=0;i<7;i++) sbuf[i]='0'; 		// Make pattern
	sbuf[3]='1'; 
	sbuf[9]='1';

	if (num[0]=='+') {sbuf[8]='9'; i=1;} 	// If the number is international
	else {sbuf[8]='8'; i=0;}
	j=11; n=0;

//	menuSettings.DebugOut("a");

	while((num[i]<='9')&&(num[i]>='0'))	// Number
	{
		sbuf[j]=num[i++]; 
//		menuSettings.DebugOut(i+" "+sbuf[j]+" ");
		n++;
		if((j&1) != 0) j--; else j+=3;		
	}
	if((n&1) != 0) {sbuf[j]='F'; j+=2;} else j-=1;	// align to byte boundary

//	menuSettings.DebugOut("b");

	sbuf[7]=bin2hex(n);			// length of number
	sbuf[6]=bin2hex((byte)(n>>4));

	sbuf[j++]='0'; 				// Protocol Phone-to-phone, Operator specific
	sbuf[j++]='0'; 
	sbuf[j++]='0'; 				// Charset UNICODE
	sbuf[j++]='8';

	n=(byte)j; j+=2; i=0;				// Encode the message

//	menuSettings.DebugOut("c");
	
//	menuSettings.DebugOut("len(msg)="+msg.length+"\n\r");

	while( ( u=(short)msg[i] ) !=0 )
	{
		sbuf[j++] = bin2hex((byte)(u>>12));
		sbuf[j++] = bin2hex((byte)(u>>8));
		sbuf[j++] = bin2hex((byte)(u>>4));
		sbuf[j++] = bin2hex((byte)(u));
		i++;
//		menuSettings.DebugOut(" i="+i+",j="+j);
	}

//	menuSettings.DebugOut("d");

	i<<=1; 					// Length of message (UNICODE is twice longer)
	sbuf[n++]=bin2hex((byte)(i>>4));
	sbuf[n++]=bin2hex((byte)i);
	sbuf[j]=0x1A;				// End of pdu
	sbuf[j+1]=13;				// End of the string
	sbuf[j+2]=0;				// End of the string

	return ((j>>1)-1);			// Length of pdu for +CMGS command
	}
	
/**
 * Отправить SMS на заданный номер. Понимает русские SMS (можно
 * писать в теле программы по-русски, Unicode)
 * @param anum - номер, на который надо послать SMS 
 * @param amsg
 */	
	public void sendSMS(String anum, String amsg)
	{
		byte num[] = new byte[anum.length()+10];
		
		byte[] snum = anum.getBytes();
		char[] smsg = new char[amsg.length()+10];
		amsg.getChars(0, amsg.length(), smsg, 0);
		
		for(int i=0; i<anum.length(); i++)
			num[i] = snum[i];
		
		int len;
		len=create_pdu_mem(num,smsg);
		try 
		{
			menuSettings.DebugOut("\n\r"+"sending "+"AT+CMGS="+len+"\r"+"\n\r");
			String strAnswer = atCommand.send("AT+CMGS="+len+"\r");
			if(strAnswer.indexOf((int)'>') > 0)
			{
				String strAT2 = new String(sbuf, 0, sbuf.length); //
				menuSettings.DebugOut("\n\r"+"strAT2.length="+strAT2.length()+"\n\r");
				menuSettings.DebugOut("\n\r"+"sending "+strAT2+"\n\r");
				String strAnswer2 = atCommand.send(strAT2);
				menuSettings.DebugOut("\n\r"+"Answer: "+strAnswer2+"\n\r");
			}
		} 
		catch (IllegalStateException e) 
		{
			menuSettings.DebugOut("IllegalStateException "+e.getMessage()+"\n\r");
		} 
		catch (IllegalArgumentException e) 
		{
			menuSettings.DebugOut("IllegalArgumentException "+e.getMessage()+"\n\r");
		} 
		catch (ATCommandFailedException e) 
		{
			menuSettings.DebugOut("ATCommandFailedException "+e.getMessage()+"\n\r");
		}
	}
	
	/**
	 * Вызывать эту функцию периодически, она будет спрашивать, есть ли
	 * новые СМС. Если есть - будет получать его и удалять из памяти.
	 * @return true если СМС есть.
	 */
	public boolean PollNewSMS()
	{
		return receiveSMS();
	}
	
	/**
	 * Если PollNewSMS() или receiveSMS() вернули true, можно получить  
	 * последний полученный СМС. 
	 * @return текст последнего полученного СМС.
	 */
	public String GetLastSms()
	{
		return strLastSms;
	}
}

	
