package upsControl;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;

public class Tc65Io {
	ATCommand		atCommand;
	MenuSettings menuSettings;
	boolean InputValue[];  // Массив состояний входов
	boolean InputActiveLevel[];  // Массив активных состояний входов -
	// какие считать активными.
	
// Массив счетчиков, менялось ли состояние входа с последнего опроса
// и сколько раз оно менялось. Например, кнопка была только нажата 
// или отжата тоже. 
	int InputChanged[];  
	
	boolean constructOk = false;
	
	public Tc65Io(ATCommand atCommand, MenuSettings menuSettings)
	{
		// Используем отдельный парсер АТ-команд, чтобы не мешал посылать СМС
        try 
        {
			this.atCommand = atCommand;// */ new ATCommand(false);
			constructOk = true;
		} 
        catch (IllegalStateException e) 
        {
			constructOk = false;
		} 
/*        catch (ATCommandFailedException e) 
		{
			constructOk = false;
		}*/

		this.menuSettings = menuSettings; //for debug

        InputChanged = new int[10];
        InputValue = new boolean[10];
        InputActiveLevel = new boolean[10];
        for(int i=0; i<10; i++)
        	InputActiveLevel[i] = false; 
        InputActiveLevel[3] = true; 
        InputActiveLevel[4] = true; 
        
//        constructOk = true;
        if(constructOk == false)
        	menuSettings.DebugOut("ERROR initializing Tc65Io!\n\r");
	}

	/**
	 * Настройка порта ввода-вывода
	 *
	 */
	public boolean initIo()
	{
		boolean bRet = constructOk; // если в констркуторе что-то не получилось - всех на фиг.
		
		try
		{
			menuSettings.DebugOut(atCommand.send("AT^SPIO=0\r")); // Выключить порт I/O
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SPIO=1\r")); // Включить порт I/O
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,0,0\r")); //   Вкл. GPIO1, input 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,0\r")); //   Вкл. поллинг GPIO1  
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,1,0\r")); //   Вкл. GPIO2, input 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,1\r")); //   Вкл. поллинг GPIO2  
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,2,0\r")); //   Вкл. GPIO3, input 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,2\r")); //   Вкл. поллинг GPIO3  
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,3,0\r")); //   Вкл. GPIO4, input 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,3\r")); //   Вкл. поллинг GPIO4  
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,4,0\r")); //   Вкл. GPIO5, input 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,4\r")); //   Вкл. поллинг GPIO5  
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,5,1,0\r")); // Вкл. GPIO6, out, init_state=0 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,6,1,0\r")); // Вкл. GPIO7, out, init_state=0 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,7,1,0\r")); // Вкл. GPIO8, out, init_state=0 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,8,1,0\r")); // Вкл. GPIO9, out, init_state=0 
			Thread.sleep(100);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,9,1,0\r")); // Вкл. GPIO10, out, init_state=0 
			Thread.sleep(100);
			// Забиваем на ответ типа ERROR.
			//			DebugOut("I/O initialized\n\r");
		}
		catch(ATCommandFailedException e)
		{
			menuSettings.DebugOut("ERROR: I/O init failed\n\r");
//			DebugOut(e.getMessage());
			bRet = false;
		}
		catch(InterruptedException e)
		{
			menuSettings.DebugOut("ERROR: I/O init failed\n\r");
//			DebugOut(e.getMessage());
			bRet = false;
		}
		return bRet;
	}
	
	/**
	 * Обновляет состояние входов. На всякий случай есть 
	 * смысл вызывать раз в 5-10 секунд, если вдруг не 
	 * поймаем AT^SCPOL
	 *
	public void RefreshInputs()
	{
		for(int i=2; i<5; i++)
		{
			boolean in = inIo(i); 
			if(InputValue[i] != in)
			{
				InputValue[i] = in;
				InputChanged[i]++;
			}
//			menuSettings.DebugOut(in?"1":"0");
		}
	}
	*/
/**
 * Вызывать из ATCommandListener, когда пришла строка ^SCPOL:
 * @param pol
 *	
	public void OnReceiveSCPOL(String pol)
	{
//		menuSettings.DebugOut(pol);
		int pos = pol.indexOf("^SCPOL:");
		if(pos != -1)
		{
			pos += 7; // перешли через ":"
			int pos2 = pol.indexOf(",", pos); // где запятая
			if(pos2 == -1)
				return; // Неправильный формат
			int input = pol.charAt(pos2-1) - '0'; //0-9
			int state = pol.charAt(pos2+1) - '0'; // 0 или 1
			if(0 < input && input < 10)
			{
				boolean in = (state == 1); 
//		        menuSettings.DebugOut("i" + input + " " + state + "/i ");
				
//				menuSettings.DebugOut("v" + InputValue[input] + " " + in + "/v ");

				if(InputValue[input] != in)
				{
					InputValue[input] = in;
					// Запоминаем, если уровень __стал__ активным
					if(InputValue[input] == InputActiveLevel[input])
					{
						InputChanged[input] = 1;
				        menuSettings.DebugOut("Changed:"+input+"\r\n");
					}
				}
			}
		}
	}
	*/
	public void closeIo()
	{
		try
		{
			menuSettings.DebugOut(atCommand.send("AT^SPIO=0\r")); // Выключить порт I/O
			Thread.sleep(200);
		}
		catch(ATCommandFailedException e)
		{
			menuSettings.DebugOut("ERROR: I/O cleanup failed\n\r");
		}
		catch(InterruptedException e)
		{
			menuSettings.DebugOut("ERROR: I/O cleanup failed\n\r");
		}
	}

	/**
	 * Возвращаем true, если со времени последнего вызова состояние
	 * порта ввода становилось активным (активные состояния для
	 * каждого входа лежат в массиве InputActiveLevel[] ). 
	 */	
	public boolean GetChanged(int pin)
	{
		boolean changed = (InputChanged[pin] > 0);
		InputChanged[pin]=0;
		if(changed)
		{
			menuSettings.DebugOut("Changed=1@pin "+pin+"\n\r");
		}
		return changed;
	}

	/**
	 * Сбрасываем все нажатия и отжатия, замыкания и размыкания
	 */	
	public void ResetAllInputs()
	{
        for(int i=0; i<10; i++)
        {
        	InputChanged[i] = 0;
        	// Считаем, что входы - в неактивном состоянии
        	InputValue[i] = !InputActiveLevel[i];
        }
	}
	
	/**
	 * Вывод 1 или 0 на заданную ногу порта
	 * @param pin    IO (0-9)
	 * @param value  true/false or zero/nonzero 
	 */
	boolean outIo(int pin, boolean value)
	{
		boolean bRet = true;
		try
		{
			// Есди здесь делать дебуг вывод, то он будет постоянно орать, т.к. мигает светодиодом.
			/*menuSettings.DebugOut(*/atCommand.send("AT^SSIO="+pin+(value==false?",0\r":",1\r"))/*+"\r\n")*/; // Включить порт I/O
		}
		catch(ATCommandFailedException e)
		{
			bRet = false;
		}
	
		return bRet;
	}
	
	boolean outIo(int pin, int value)
	{
		return outIo(pin, (value==0)?false:true);
	}

	/**
	 * Ввод состояния заданной ноги порта
	 * @param pin    IO (0-9)
	 */
	boolean inIo(int pin)
	{
		boolean bRet = false;
		try
		{
			String str = atCommand.send("AT^SGIO="+pin+"\r"); // Прочитать порт I/O
			
//			menuSettings.DebugOut(str+"\n\r");
			
			int idx = str.indexOf("^SGIO:");
			if(idx > 0)
			{
				// "^SGIO: 0"
				char c = str.charAt(idx + 7);
				if(c == '1') // "^SGIO: 1"
					bRet = true;
			}
//			menuSettings.DebugOut(str);
		}
		catch(ATCommandFailedException e)
		{
			//DebugOut(e.getMessage());
			menuSettings.DebugOut("ATCommandFailedException");
			bRet = false;
		}
		return bRet;
	}
}
